;##################################################################
; Font Menu
;##################################################################

IDD_DLG1 equ 1000

#Define WM_INITDIALOG 110h
#Define WM_COMMAND 111h
#Define WM_DRAWITEM 2Bh
#Define WM_MEASUREITEM 2Ch
#Define WM_SETFONT 30h
#Define WM_GETFONT 31h
#Define WM_CLOSE 10h

#Define NULL 0
#Define FALSE 0
#Define TRUE 1

#Define MF_BYCOMMAND 0h
#Define MF_BYPOSITION 400h
#Define MF_ENABLED 0h
#Define MF_STRING 0h
#Define MF_OWNERDRAW 100h
#Define MF_POPUP 10h
#Define MF_UNCHECKED 0h
#Define MF_CHECKED 8h
#Define ODT_MENU 1
#Define ODS_SELECTED 1h
#Define MIIM_DATA 20h

#Define IMAGE_BITMAP 0
#Define LR_CREATEDIBSECTION 2000h
#Define ILD_NORMAL 0000h
#Define COLOR_BTNFACE 15

#Define DT_LEFT 0h
#Define DT_VCENTER 4h
#Define DT_SINGLELINE 20h
#Define ANSI_CHARSET 0
#Define FW_NORMAL 400

#Define MNS_AUTODISMISS 10000000h
#Define MIM_STYLE 10h

#Define LF_FACESIZE 32
#Define LF_FULLFACESIZE 64

LOGFONT STRUCT
  lfHeight          DD
  lfWidth           DD
  lfEscapement      DD
  lfOrientation     DD
  lfWeight          DD
  lfItalic          DB
  lfUnderline       DB
  lfStrikeOut       DB
  lfCharSet         DB
  lfOutPrecision    DB
  lfClipPrecision   DB
  lfQuality         DB
  lfPitchAndFamily  DB
  lfFaceName        DB LF_FACESIZE dup ?
ENDS

ENUMLOGFONTEX STRUCT
  elfLogFont        LOGFONT <?>
  elfFullName       DB LF_FULLFACESIZE dup
  elfStyle          DB LF_FACESIZE dup
  elfScript         DB LF_FACESIZE dup
ENUMLOGFONTEX ENDS

LOGBRUSH STRUCT
  lbStyle  DD
  lbColor  DD
  lbHatch  DD
ENDS

RECT STRUCT
  left    dd
  top     dd
  right   dd
  bottom  dd
ENDS

MENUINFO STRUCT
   cbSize          DD
   fmask           DD
   dwstyle         DD
   cyMax           DD
   hbrBack         DD
   dwContextHelpID DD
   dwMenuData      DD
MENUINFO ENDS

DRAWITEMSTRUCT STRUCT
  CtlType       DD
  CtlID         DD
  itemID        DD
  itemAction    DD
  itemState     DD
  hwndItem      DD
  hdc           DD
  rcItem        RECT <?>
  itemData      DD
ENDS

MEASUREITEMSTRUCT STRUCT
  CtlType       DD
  CtlID         DD
  itemID        DD
  itemWidth     DD
  itemHeight    DD
  itemData      DD
ENDS

MENUITEMINFO STRUCT
  cbSize        DD
  fMask         DD
  fType         DD
  fState        DD
  wID           DD
  hSubMenu      DD
  hbmpChecked   DD
  hbmpUnchecked DD
  dwItemData    DD
  dwTypeData    DD
  cch           DD
ENDS

.DATA
	CurrentFont		DD			0
	szFontMenuLabel	DB			"Fonts",0

	ALIGN 4
	hInstance		DD 			?
	hMNBrush		DD			?
	hMenu			DD			?
	hFontMenu		DD			?
	hDlg			DD			?

	nItemNum		DD			?

	hChkIML			DD			?

.CODE

Start:
	invoke GetModuleHandleA, 0
	mov [hInstance],eax
	; Common Controls is needed for the imagelist functions
	invoke InitCommonControls
	; Create a brush to use as the Selection color
	invoke CreateSolidBrush,00FF8080h
	mov [hMNBrush],eax
	; load the check marks image list from the resource section of our app
	invoke ImageList_LoadImage,[hInstance],5000,11,10,0FFFFFFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hChkIML],eax
	invoke DialogBoxParamA,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	; Clean up the resources and shut down
	invoke DeleteObject,[hMNBrush]
	invoke DestroyMenu,[hFontMenu]
	invoke DestroyMenu,[hMenu]
	invoke ImageList_Destroy,[hChkIML]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL lf		:LOGFONT
	LOCAL rect		:RECT
	LOCAL lbr		:LOGBRUSH
	LOCAL mii		:MENUITEMINFO
	LOCAL mi		:MENUINFO

	mov eax,[uMsg]

	cmp eax,WM_INITDIALOG
	jne >>.WMDRAWITEM
		mov eax,[hwnd]
		mov [hDlg],eax
		; Create a menu bar for our dialog
		invoke CreateMenu
		mov [hMenu],eax
		; Assign the menu to the dialog
		invoke SetMenu,[hwnd],eax
		; Create a submenu for the fonts
		invoke CreatePopupMenu
		mov [hFontMenu],eax
		
		mov D[mi.cbSize],SIZEOF MENUINFO
		mov D[mi.fmask],MIM_STYLE
		mov D[mi.dwstyle],MNS_AUTODISMISS
		;invoke SetMenuInfo,[hFontMenu],OFFSET mi

		; Enumerate the fonts and add them to the menu, enumerate for ANSI_CHARSET
		invoke BuildFontMenu,eax,ANSI_CHARSET
		; Add our font menu to the menu bar
		invoke InsertMenuA,[hMenu],0,MF_BYPOSITION + MF_POPUP + MF_STRING,[hFontMenu],OFFSET szFontMenuLabel
		; Redraw the menu bar to display the font menu
		invoke DrawMenuBar,[hwnd]
		jmp >>.EXIT

	.WMDRAWITEM
	cmp eax,WM_DRAWITEM
	jne >>.WMMEASUREITEM
		; If wParam is 0 then Windows is asking to draw a menu item
		cmp D[wParam],0
		jne >>.DEFPROC
			; lParam hold a pointer to the DRAWITEMSTRUCT structure
			; We will use this structure to give us references for drawing
			; Just to make sure this is a menu we will verify the control type
			mov edi,[lParam]
			mov eax,[edi+DRAWITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >>.DEFPROC
				; itemAction tells us what type of drawing is taking place
				; for menus we need to draw for ODA_DRAWENTIRE and ODA_SELECT
				; for our purpose we will not distinguish between itemActions
				; Get the item state (either selected or not)
				mov eax,[edi+DRAWITEMSTRUCT.itemState]
				test eax,ODS_SELECTED
				je >>S1
					; This menu item is selected so we will use the menu
					; brush, first we need the color of the brush for the
					; font background color
					mov ebx,0FFFFFFh
					mov esi,[hMNBrush]
					invoke GetObjectA,esi,SIZEOF LOGBRUSH,OFFSET lbr
					push [lbr.lbColor]
					jmp >S2
				S1:
					; This menu item is not selected so we will create a
					; brush from COLOR_BUTTONFACE
					mov ebx,0
					invoke GetSysColor,COLOR_BTNFACE
					push eax
					invoke CreateSolidBrush,eax
					mov esi,eax
				S2:
					pop eax
					invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax
					push eax ; push the old background color

					; Set the text color to WHITE
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],ebx
					push eax ; push the old text color

					; The itemData member has our font handle we need to extract the
					; name of the font to draw it
					invoke GetObjectA,[edi+DRAWITEMSTRUCT.itemData],SIZEOF LOGFONT,OFFSET lf

					; Select the font into the menu's DC so any text will be drawn with that font
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],[edi+DRAWITEMSTRUCT.itemData]
					push eax ; Push the old object onto the stack

					; Calculate the offset of the bounding RECT structure for the item
					; we are drawing
					mov ebx,edi
					add ebx,DRAWITEMSTRUCT.rcItem

					; Fill the bounding rectangle with the selection brush
					invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ebx,esi
					
					; Get the indent we will need to draw the text and add it to the left
					; side of the rect, we don't have to return this structure so we will
					; write directly to it
					invoke GetMenuCheckMarkDimensions
					and eax,0FFFFh ; The low order word contains the width
					add [edi+DRAWITEMSTRUCT.rcItem.left],eax

					invoke lstrlen,OFFSET lf.lfFaceName
					or eax,eax
					jnz >
						invoke lstrcpy,OFFSET lf.lfFaceName,"Custom font"
					:
					; Draw the text and restore all of the objects and colors
					invoke DrawTextA,[edi+DRAWITEMSTRUCT.hdc],OFFSET lf.lfFaceName,-1,ebx,DT_LEFT + DT_VCENTER + DT_SINGLELINE
					pop eax
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax

					; Draw the check mark if necessary
					mov ebx,edi
					add ebx,DRAWITEMSTRUCT.rcItem
					invoke GetMenuCheckMarkDimensions
					and eax,0FFFFh ; The low order word contains the width
					sub [edi+DRAWITEMSTRUCT.rcItem.left],eax

					; Center the image vertically we need to know the height of the checkmark
					invoke ImageList_GetIconSize,[hChkIML],OFFSET rect.left,OFFSET rect.top
					or eax,eax
					je >S3 ; No image list or an error so don't draw it

					mov ecx,[edi+DRAWITEMSTRUCT.rcItem.bottom]
					sub ecx,[edi+DRAWITEMSTRUCT.rcItem.top]
					sub ecx,[rect.left]
					shr ecx,1
					add [edi+DRAWITEMSTRUCT.rcItem.top],ecx

					; Is the menu item checked ??
					xor eax,eax
					test D[edi+DRAWITEMSTRUCT.itemState],MF_CHECKED
					je >
						inc eax
					:
					invoke ImageList_Draw,[hChkIML],eax,[edi+DRAWITEMSTRUCT.hdc],[ebx+RECT.left],[ebx+RECT.top],ILD_NORMAL

					mov eax,[edi+DRAWITEMSTRUCT.itemState]
					test eax,ODS_SELECTED
					jne >S3
						; Destroy the brush if it was a normal menu item
						invoke DeleteObject,esi
				S3:
					xor eax,eax
					inc eax
					ret

	.WMMEASUREITEM
	cmp eax,WM_MEASUREITEM
	jne >>.WMCOMMAND
		; The WM_MEASUREITEM message is sent for owner drawn controls
		; to tell Windows how big it will be
		; lParam hold a pointer to the MEASUREITEMSTRUCT structure
		; We will return this structure with the measurements of our control
		mov edi,[lParam]
		; If wParam is 0 then Windows is asking to measure a menu item
		cmp D[wParam],0
		jne >>.DEFPROC
			; Just to make sure this is a menu we will verify the control type
			mov eax,[edi+MEASUREITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >>.DEFPROC
				; To measure the size of the text we must select it into a DC
				; We create a memory DC for this
				invoke GetDC,NULL
				mov ebx,eax
				invoke CreateCompatibleDC,ebx
				mov esi,eax
				invoke SelectObject,esi,[edi+MEASUREITEMSTRUCT.itemData]
				; Save the old object in the DC on the stack
				push eax
				; We stored the font handle in the lParam of the menu item
				; it is passed in MEASUREITEMSTRUCT.itemData, we will use that
				; to read the full LOGFONT structure to get the font name
				invoke GetObjectA,[edi+MEASUREITEMSTRUCT.itemData],SIZEOF LOGFONT,OFFSET lf
				; we need the length of the name
				invoke lstrlen,OFFSET lf.lfFaceName
				; Have Windows calculate the width and height of the string
				; This function takes a POINT structure but we will just reuse the rect
				; structure used elsewhere to limit the DlgProc stack size
				invoke GetTextExtentPoint32A,esi,OFFSET lf.lfFaceName,eax,OFFSET rect
				; Pop the old object in the DC off the stack and select it back into the DC
				pop ecx
				invoke SelectObject,esi,ecx
				; Delete the memory DC and release the screen DC
				invoke DeleteDC,esi
				invoke ReleaseDC,NULL,ebx
				; We need to know how much space to leave for a check mark
				; This information is obtained from GetMenuCheckMarkDimensions
				; add it to the left side of the rectangle (width)
				invoke GetMenuCheckMarkDimensions
				mov edx,eax
				shr edx,16 ; The high order word contains the height (EDX)
				and eax,0FFFFh ; The low order word contains the width (EAX)
				add eax,[rect.left]
				; Set the width of this item
				mov D[edi+MEASUREITEMSTRUCT.itemWidth],eax
				; if our height is below the height of a checkmark we 
				; set it to that value
				add edx,2 ; make sure we leave a pixel on the top and bottom
				mov ecx,[rect.top]
				cmp ecx,edx
				ja >
					mov ecx,edx
				:
				mov D[edi+MEASUREITEMSTRUCT.itemHeight],ecx
				xor eax,eax
				inc eax
				ret

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMCLOSE
		; Get the command ID
		xor eax,eax
		mov ax,W[wParam]
		; Set up the MENUITEMINFO structure
		mov D[mii.cbSize],SIZEOF MENUITEMINFO
		mov D[mii.fMask],MIIM_DATA
		mov D[mii.dwItemData],0
		; Extract the information from this menu item
		invoke GetMenuItemInfoA,[hMenu],eax,MF_BYCOMMAND,OFFSET mii
		; Make sure that it has a font handle in dwItemData
		cmp D[mii.dwItemData],0
		je >>.EXIT
			; Extract the LOGFONT information for this menu item
			; We will use that as a starting point for creating a new
			; font for use in the edit control
			invoke GetObjectA,[mii.dwItemData],SIZEOF LOGFONT,OFFSET lf
			; Modify the LOGFONT structure based on the users choices
			; do not modify the lf.lfFaceName or lf.lfPitchAndFamily members
			mov eax,-15 ; Display height of font
			mov [lf.lfHeight],eax
			mov D[lf.lfWidth],0
			; Create a new font for the edit
			invoke CreateFontIndirectA,OFFSET lf
			mov ebx,eax
			; Get the old font and delete it
			; if there was no user selected font it will be a
			; system defined font (Stock Object) and it does no
			; harm to delete it anyway
			invoke SendDlgItemMessageA,[hwnd],1001,WM_GETFONT,0,0
			invoke DeleteObject,eax ; destroy the old display font
			; Set the new font for the edit, redraw must be set to TRUE
			invoke SendDlgItemMessageA,[hwnd],1001,WM_SETFONT,ebx,TRUE
			; Reset the checkmark on the old font (ID stored in [CurrentFont])
			invoke CheckMenuItem,[hMenu],[CurrentFont],MF_BYCOMMAND + MF_UNCHECKED
			; Set the checkmark in the new font selection and update [CurrentFont]
			xor eax,eax
			mov ax,W[wParam]
			mov [CurrentFont],eax
			invoke CheckMenuItem,[hMenu],eax,MF_BYCOMMAND + MF_CHECKED

		jmp >>.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		; To be good WinCitizens we must clean up before we leave
		; Step through the font menu and extract the font handles
		; and delete them.
		mov D[mii.cbSize],SIZEOF MENUITEMINFO
		mov D[mii.fMask],MIIM_DATA
		mov ebx,5001
		invoke GetMenuItemInfoA,[hMenu],ebx,MF_BYCOMMAND,OFFSET mii
		jmp >W2
		W1:
			invoke DeleteObject,[mii.dwItemData]
			mov D[mii.dwItemData],0
			inc ebx
			invoke GetMenuItemInfoA,[hMenu],ebx,MF_BYCOMMAND,OFFSET mii
		W2:
		cmp D[mii.dwItemData],0
		jne <W1
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

BuildFontMenu FRAME SubMenuHandle,CharSet
	uses ebx,esi
	LOCAL lf	:LOGFONT

	; To enumerate the fonts we must suuply the information in
	; a LOGFONT structure to control the enumeration. The API will
	; read the lfCharSet, lfFaceName and lfPitchAndFamily members of
	; the structure. Always set the lfPitchAndFamily member to 0. If
	; you wish to enumerate all families set lfFaceName to 0. It is
	; good idea to supply a character set or you may get multiple
	; instances of the same font (one for each character set)
	; For the purposes of the menu we pass the menu handle of the Font menu
	; to the enumerator in lParam, this let's it add the menu items directly
	; as part of the enumeration
	mov D[nItemNum],6001
	mov eax,[CharSet]
	mov B[lf.lfCharSet],al
	mov B[lf.lfFaceName],0
	mov B[lf.lfPitchAndFamily],0 
	invoke GetDlgItem,[hDlg],1001
	mov esi,eax
	invoke GetDC,esi
	mov ebx,eax
	invoke EnumFontFamiliesExA,ebx,ADDR lf,OFFSET EnumFontFamExProc,[SubMenuHandle],0
	invoke ReleaseDC,esi,ebx
	RET
ENDF

EnumFontFamExProc FRAME lpelfe,lpntme,FontType,lParam
	uses ebx

	; Get the data from the font and create a font of a fixed height
	; for the menu to display
	mov ebx,[lpelfe]
	add ebx,ENUMLOGFONTEX.elfLogFont
	mov D[ebx+LOGFONT.lfHeight],-13
	mov D[ebx+LOGFONT.lfWidth],0
	mov D[ebx+LOGFONT.lfWeight],FW_NORMAL
	invoke CreateFontIndirectA,ebx
	; Add this font to the menu
	invoke AppendMenuA,[lParam],MF_ENABLED + MF_OWNERDRAW,[nItemNum],eax
	inc D[nItemNum]
	
	mov eax,TRUE
	RET
ENDF
